Index: sys/sys/systm.h
===================================================================
RCS file: /cvsroot/src/sys/sys/systm.h,v
retrieving revision 1.258
diff -u -r1.258 systm.h
--- sys/sys/systm.h	18 Mar 2013 13:36:23 -0000	1.258
+++ sys/sys/systm.h	24 Jun 2013 19:14:25 -0000
@@ -57,6 +57,7 @@
 struct clockframe;
 struct lwp;
 struct proc;
+struct sysent;
 struct timeval;
 struct tty;
 struct uio;
@@ -115,11 +116,32 @@
 
 typedef int	sy_call_t(struct lwp *, const void *, register_t *);
 
+/* Used by the machine dependent syscall() code. */
+typedef void (*systrace_probe_func_t)(u_int32_t, int,
+    const struct sysent *, void *);
+
+/*
+ * Used by loaded syscalls to convert arguments to a DTrace array
+ * of 64-bit arguments.
+ */
+union systrace_probe_args_un {
+        uint64_t        u;
+        int64_t         s;
+};
+typedef void (*systrace_args_func_t)(int, void *,
+    union systrace_probe_args_un *, int *);
+
+extern systrace_probe_func_t    systrace_probe_func;
+
 extern struct sysent {		/* system call table */
 	short	sy_narg;	/* number of args */
 	short	sy_argsize;	/* total size of arguments */
 	int	sy_flags;	/* flags. see below */
 	sy_call_t *sy_call;     /* implementing function */
+	systrace_args_func_t sy_systrace_args_func;
+				/* optional argument conversion function. */
+	u_int32_t sy_entry;     /* DTrace entry ID for systrace. */
+	u_int32_t sy_return;    /* DTrace return ID for systrace. */
 } sysent[];
 extern int nsysent;
 #if	BYTE_ORDER == BIG_ENDIAN
--- /dev/null	2013-06-24 12:30:14.000000000 -0700
+++ sys/modules/dtrace/systrace/Makefile	2013-06-24 12:31:00.000000000 -0700
@@ -0,0 +1,16 @@
+# $NetBSD$
+
+.include "../../Makefile.inc"
+
+.PATH: ${NETBSDSRCDIR}/external/cddl/osnet/dev/systrace
+
+WARNS=2
+KMOD=		systrace
+SRCS=		systrace.c
+
+CPPFLAGS+=	-I${NETBSDSRCDIR}/external/cddl/osnet/sys \
+		-I${NETBSDSRCDIR}/external/cddl/osnet/dist/uts/common 
+
+CPPFLAGS+=	-Wno-unknown-pragmas
+
+.include <bsd.kmodule.mk>
